org.openstreetmap.josm.plugins.streetside.gui

## Class StreetsideMainDialog

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - org.openstreetmap.josm.gui.dialogs.ToggleDialog
          - - org.openstreetmap.josm.plugins.streetside.gui.StreetsideMainDialog

- All Implemented Interfaces:
    java.awt.event.AWTEventListener, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.util.EventListener, javax.accessibility.Accessible, org.openstreetmap.josm.data.cache.ICachedLoaderListener, org.openstreetmap.josm.gui.help.Helpful, org.openstreetmap.josm.gui.ShowHideButtonListener, StreetsideDataListener, org.openstreetmap.josm.spi.preferences.PreferenceChangedListener, org.openstreetmap.josm.tools.Destroyable

      public final class StreetsideMainDialog
      extends org.openstreetmap.josm.gui.dialogs.ToggleDialog
      implements org.openstreetmap.josm.data.cache.ICachedLoaderListener, StreetsideDataListener

  Toggle dialog that shows an image and some buttons.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `private static class` | `StreetsideMainDialog.BlueAction` Action class to jump to the image following the blue line.
    `static class` | `StreetsideMainDialog.MODE` Buttons mode.
    `private static class` | `StreetsideMainDialog.NextPictureAction` Action class form the next image button.
    `private static class` | `StreetsideMainDialog.PauseAction`
    `private static class` | `StreetsideMainDialog.PlayAction`
    `private static class` | `StreetsideMainDialog.PreviousPictureAction` Action class for the previous image button.
    `private static class` | `StreetsideMainDialog.RedAction` Action class to jump to the image following the red line.
    `private static class` | `StreetsideMainDialog.StopAction`

    - ### Nested classes/interfaces inherited from class org.openstreetmap.josm.gui.dialogs.ToggleDialog

      `org.openstreetmap.josm.gui.dialogs.ToggleDialog.ButtonHidingType, org.openstreetmap.josm.gui.dialogs.ToggleDialog.TitleBar, org.openstreetmap.josm.gui.dialogs.ToggleDialog.ToggleDialogAction`

    - ### Nested classes/interfaces inherited from class javax.swing.JPanel

      `javax.swing.JPanel.AccessibleJPanel`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

    - ### Nested classes/interfaces inherited from interface org.openstreetmap.josm.data.cache.ICachedLoaderListener

      `org.openstreetmap.josm.data.cache.ICachedLoaderListener.LoadResult`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `BASE_TITLE`
    `org.openstreetmap.josm.gui.SideButton` | `blueButton` Button used to jump to the image following the blue line
    `private StreetsideAbstractImage` | `image`
    `private StreetsideCache` | `imageCache`
    `private ImageInfoHelpPopup` | `imageInfoHelp`
    `private static StreetsideMainDialog` | `instance`
    `(package private) static org.apache.log4j.Logger` | `logger`
    `private static java.lang.String` | `MESSAGE_SEPARATOR`
    `org.openstreetmap.josm.gui.SideButton` | `nextButton`
    `private org.openstreetmap.josm.gui.SideButton` | `pauseButton`
    `private org.openstreetmap.josm.gui.SideButton` | `playButton`
    `org.openstreetmap.josm.gui.SideButton` | `previousButton`
    `org.openstreetmap.josm.gui.SideButton` | `redButton` Button used to jump to the image following the red line
    `private static long` | `serialVersionUID`
    `private org.openstreetmap.josm.gui.SideButton` | `stopButton`
    `StreetsideImageDisplay` | `streetsideImageDisplay` Object containing the shown image and that handles zoom and drag
    `private StreetsideViewerHelpPopup` | `streetsideViewerHelp`
    `StreetsideCache` | `thumbnailCache`

    - ### Fields inherited from class org.openstreetmap.josm.gui.dialogs.ToggleDialog

      `button, buttonHiding, detachedDialog, dialogsPanel, isCollapsed, isDocked, isShowing, name, preferenceClass, preferencePrefix, PROP_DYNAMIC_BUTTONS, titleBar, toggleAction, windowMenuItem`

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `private` | `StreetsideMainDialog()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private void` | `addShortcuts()` Adds the shortcuts to the buttons.
    `void` | `createLayout(java.awt.Component data, java.util.List<org.openstreetmap.josm.gui.SideButton> buttons)` Creates the layout of the dialog.
    `static void` | `destroyInstance()` Destroys the unique instance of the class.
    `void` | `disableAllButtons()` Disables all the buttons in the dialog
    `StreetsideAbstractImage` | `getImage()` Returns the `StreetsideAbstractImage` object which is being shown.
    `static StreetsideMainDialog` | `getInstance()` Returns the unique instance of the class.
    `StreetsideImageDisplay` | `getStreetsideImageDisplay()`
    `StreetsideViewerHelpPopup` | `getStreetsideViewerHelp()`
    `static boolean` | `hasInstance()`
    `void` | `imagesAdded()` Fired when any image is added to the database.
    `void` | `loadingFinished(org.openstreetmap.josm.data.cache.CacheEntry data, org.openstreetmap.josm.data.cache.CacheEntryAttributes attributes, org.openstreetmap.josm.data.cache.ICachedLoaderListener.LoadResult result)` When the pictures are returned from the cache, they are set in the `StreetsideImageDisplay` object.
    `void` | `selectedImageChanged(StreetsideAbstractImage oldImage, StreetsideAbstractImage newImage)` Fired when the selected image is changed by something different from manually clicking on the icon.
    `void` | `setImage(StreetsideAbstractImage image)` Sets a new StreetsideImage to be shown.
    `void` | `setImageInfoHelp(ImageInfoHelpPopup popup)`
    `void` | `setMode(StreetsideMainDialog.MODE mode)` Sets a new mode for the dialog.
    `void` | `setStreetsideImageDisplay(StreetsideImageDisplay streetsideImageDisplay)`
    `void` | `setStreetsideViewerHelp(StreetsideViewerHelpPopup popup)`
    `void` | `updateImage()` Downloads the full quality picture of the selected StreetsideImage and sets in the StreetsideImageDisplay object.
    `void` | `updateImage(boolean fullQuality)` Downloads the picture of the selected StreetsideImage and sets in the StreetsideImageDisplay object.
    `void` | `updateTitle()` Updates the title of the dialog.

    - ### Methods inherited from class org.openstreetmap.josm.gui.dialogs.ToggleDialog

      `buttonHidden, buttonShown, closeDetachedDialog, collapse, createLayout, createLayout, destroy, detach, dock, dockWhenClosingDetachedDlg, eventDispatched, expand, getButton, getDefaultDetachedSize, getName, getPreferencePrefix, getPreferredHeight, getToggleAction, helpTopic, hideDialog, hideNotify, isDialogInCollapsedView, isDialogInDefaultView, isDialogShowing, preferenceChanged, registerInWindowMenu, setButton, setContentVisible, setDialogsPanel, setIsButtonHiding, setIsCollapsed, setIsDocked, setIsShowing, setTitle, showDialog, showNotify, stateChanged, toggleButtonHook, toString, unfurlDialog`

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### serialVersionUID

          private static final long serialVersionUID

      See Also:
        Constant Field Values

    - #### logger

          static final org.apache.log4j.Logger logger

    - #### BASE_TITLE

          public static final java.lang.String BASE_TITLE

    - #### MESSAGE_SEPARATOR

          private static final java.lang.String MESSAGE_SEPARATOR

      See Also:
        Constant Field Values

    - #### instance

          private static StreetsideMainDialog instance

    - #### image

          private volatile StreetsideAbstractImage image

    - #### nextButton

          public final org.openstreetmap.josm.gui.SideButton nextButton

    - #### previousButton

          public final org.openstreetmap.josm.gui.SideButton previousButton

    - #### redButton

          public final org.openstreetmap.josm.gui.SideButton redButton

      Button used to jump to the image following the red line

    - #### blueButton

          public final org.openstreetmap.josm.gui.SideButton blueButton

      Button used to jump to the image following the blue line

    - #### playButton

          private final org.openstreetmap.josm.gui.SideButton playButton

    - #### pauseButton

          private final org.openstreetmap.josm.gui.SideButton pauseButton

    - #### stopButton

          private final org.openstreetmap.josm.gui.SideButton stopButton

    - #### imageInfoHelp

          private ImageInfoHelpPopup imageInfoHelp

    - #### streetsideViewerHelp

          private StreetsideViewerHelpPopup streetsideViewerHelp

    - #### streetsideImageDisplay

          public StreetsideImageDisplay streetsideImageDisplay

      Object containing the shown image and that handles zoom and drag

    - #### imageCache

          private StreetsideCache imageCache

    - #### thumbnailCache

          public StreetsideCache thumbnailCache

  - ### Constructor Detail

    - #### StreetsideMainDialog

          private StreetsideMainDialog()

  - ### Method Detail

    - #### addShortcuts

          private void addShortcuts()

      Adds the shortcuts to the buttons.

    - #### getInstance

          public static StreetsideMainDialog getInstance()

      Returns the unique instance of the class.
      Returns:
        The unique instance of the class.

    - #### hasInstance

          public static boolean hasInstance()

      Returns:
        true, iff the singleton instance is present

    - #### setImageInfoHelp

          public void setImageInfoHelp(ImageInfoHelpPopup popup)

    - #### setStreetsideViewerHelp

          public void setStreetsideViewerHelp(StreetsideViewerHelpPopup popup)

    - #### getStreetsideViewerHelp

          public StreetsideViewerHelpPopup getStreetsideViewerHelp()

      Returns:
        the streetsideViewerHelp

    - #### setMode

          public void setMode(StreetsideMainDialog.MODE mode)

      Sets a new mode for the dialog.
      Parameters:
        `mode` - The mode to be set. Must not be `null`.

    - #### destroyInstance

          public static void destroyInstance()

      Destroys the unique instance of the class.

    - #### updateImage

          public void updateImage()

      Downloads the full quality picture of the selected StreetsideImage and sets in the StreetsideImageDisplay object.

    - #### updateImage

          public void updateImage(boolean fullQuality)

      Downloads the picture of the selected StreetsideImage and sets in the StreetsideImageDisplay object.
      Parameters:
        `fullQuality` - If the full quality picture must be downloaded or just the thumbnail.

    - #### disableAllButtons

          public void disableAllButtons()

      Disables all the buttons in the dialog

    - #### setImage

          public void setImage(StreetsideAbstractImage image)

      Sets a new StreetsideImage to be shown.
      Parameters:
        `image` - The image to be shown.

    - #### updateTitle

          public void updateTitle()

      Updates the title of the dialog.

    - #### getImage

          public StreetsideAbstractImage getImage()

      Returns the `StreetsideAbstractImage` object which is being shown.
      Returns:
        The `StreetsideAbstractImage` object which is being shown.

    - #### loadingFinished

          public void loadingFinished(org.openstreetmap.josm.data.cache.CacheEntry data,
                                      org.openstreetmap.josm.data.cache.CacheEntryAttributes attributes,
                                      org.openstreetmap.josm.data.cache.ICachedLoaderListener.LoadResult result)

      When the pictures are returned from the cache, they are set in the `StreetsideImageDisplay` object.
      Specified by:
        `loadingFinished` in interface `org.openstreetmap.josm.data.cache.ICachedLoaderListener`

    - #### createLayout

          public void createLayout(java.awt.Component data,
                                   java.util.List<org.openstreetmap.josm.gui.SideButton> buttons)

      Creates the layout of the dialog.
      Parameters:
        `data` - The content of the dialog
        `buttons` - The buttons where you can click

    - #### selectedImageChanged

          public void selectedImageChanged(StreetsideAbstractImage oldImage,
                                           StreetsideAbstractImage newImage)

      Description copied from interface: `StreetsideDataListener`
      Fired when the selected image is changed by something different from manually clicking on the icon.
      Specified by:
        `selectedImageChanged` in interface `StreetsideDataListener`
      Parameters:
        `oldImage` - Old selected `StreetsideAbstractImage`
        `newImage` - New selected `StreetsideAbstractImage`

    - #### imagesAdded

          public void imagesAdded()

      Description copied from interface: `StreetsideDataListener`
      Fired when any image is added to the database.
      Specified by:
        `imagesAdded` in interface `StreetsideDataListener`

    - #### getStreetsideImageDisplay

          public StreetsideImageDisplay getStreetsideImageDisplay()

      Returns:
        the streetsideImageDisplay

    - #### setStreetsideImageDisplay

          public void setStreetsideImageDisplay(StreetsideImageDisplay streetsideImageDisplay)

      Parameters:
        `streetsideImageDisplay` - the streetsideImageDisplay to set

JOSM Plugins